/* aft0r.f -- translated by f2c (version 19970805).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int aft0r_c(real *a, real *b, real *z__, integer *n,
        integer *m, integer *ierr)
{
    /* Initialized data */

    static real ot116 = 1.1605f;
    static real zero = 0.f;
    static real one = 1.f;
    static real sys051 = 1.192093e-7f;

    /* System generated locals */
    integer a_dim1, a_offset, b_dim1, b_offset, z_dim1, z_offset, i__1, i__2;
    real r__1;

    /* Local variables */
    extern /* Subroutine */ int am12r_c(real *, real *, real *, real *, real *,
             real *), am13r_c(real *, real *, real *, real *, real *, real *,
            real *, real *, real *);
    static real epsa, epsb;
    static integer iter, morn, i__, j, k, l;
    static real t, anorm, bnorm, const__;
    static integer k1, k2, m1, m2, k3, l1;
    static logical wantx;
    static real u1, v1, v2, u2, v3, u3, a10, a11, a21, b11, a22, b12, a34, 
            b34, a43, b44, a12, a30;
    static integer lb;
    static real a44, b22, a20, a33, b33;
    static integer km1;
    static real ani, bni;
    static logical mid;
    static real eps, old1, old2;
    static integer lor1;


#define a_ref(a_1,a_2) a[(a_2)*a_dim1 + a_1]
#define b_ref(a_1,a_2) b[(a_2)*b_dim1 + a_1]
#define z___ref(a_1,a_2) z__[(a_2)*z_dim1 + a_1]

    /* Parameter adjustments */
    z_dim1 = *n;
    z_offset = z_dim1 + 1;
    z__ -= z_offset;
    b_dim1 = *n;
    b_offset = b_dim1 + 1;
    b -= b_offset;
    a_dim1 = *n;
    a_offset = a_dim1 + 1;
    a -= a_offset;

    /* Function Body */
    *ierr = 0;
    eps = sys051;
    wantx = FALSE_;
    if (*m == 0) {
        wantx = TRUE_;
    }
    anorm = zero;
    bnorm = zero;
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        ani = zero;
        if (i__ != 1) {
            ani = (r__1 = a_ref(i__, i__ - 1), abs(r__1));
        }
        bni = zero;
        i__2 = *n;
        for (j = i__; j <= i__2; ++j) {
            ani += (r__1 = a_ref(i__, j), abs(r__1));
            bni += (r__1 = b_ref(i__, j), abs(r__1));
/* L1: */
        }
        if (ani > anorm) {
            anorm = ani;
        }
        if (bni > bnorm) {
            bnorm = bni;
        }
/* L2: */
    }
    if (anorm == zero) {
        anorm = eps;
    }
    if (bnorm == zero) {
        bnorm = eps;
    }
    epsa = eps * anorm;
    epsb = eps * bnorm;
    m1 = *n;
    iter = 0;
L3:
    if (m1 <= 2) {
        goto L22;
    }
    i__1 = m1;
    for (lb = 1; lb <= i__1; ++lb) {
        l = m1 + 1 - lb;
        if (l == 1) {
            goto L6;
        }
        if ((r__1 = a_ref(l, l - 1), abs(r__1)) <= epsa) {
            goto L5;
        }
/* L4: */
    }
L5:
    a_ref(l, l - 1) = zero;
    if (l < m1 - 1) {
        goto L6;
    }
    m1 = l - 1;
    iter = 0;
    goto L3;
L6:
    if ((r__1 = b_ref(l, l), abs(r__1)) > epsb) {
        goto L9;
    }
    b_ref(l, l) = zero;
    l1 = l + 1;
    am12r_c(&a_ref(l, l), &a_ref(l1, l), &u1, &u2, &v1, &v2);
    if (u1 != one) {
        goto L8;
    }
    i__1 = *n;
    for (j = l; j <= i__1; ++j) {
        t = a_ref(l, j) + u2 * a_ref(l1, j);
        a_ref(l, j) = a_ref(l, j) + t * v1;
        a_ref(l1, j) = a_ref(l1, j) + t * v2;
        t = b_ref(l, j) + u2 * b_ref(l1, j);
        b_ref(l, j) = b_ref(l, j) + t * v1;
        b_ref(l1, j) = b_ref(l1, j) + t * v2;
/* L7: */
    }
L8:
    l = l1;
    goto L5;
L9:
    m2 = m1 - 1;
    l1 = l + 1;
    const__ = .75f;
    ++iter;
    if (iter == 1) {
        goto L10;
    }
    if ((r__1 = a_ref(m1, m1 - 1), abs(r__1)) < const__ * old1) {
        goto L10;
    }
    if ((r__1 = a_ref(m1 - 1, m1 - 2), abs(r__1)) < const__ * old2) {
        goto L10;
    }
    if (iter == 10) {
        goto L11;
    }
    if (iter > 30) {
        goto L21;
    }
L10:
    b11 = b_ref(l, l);
    b22 = b_ref(l1, l1);
    if (abs(b22) < epsb) {
        b22 = epsb;
    }
    b33 = b_ref(m2, m2);
    if (abs(b33) < epsb) {
        b33 = epsb;
    }
    b44 = b_ref(m1, m1);
    if (abs(b44) < epsb) {
        b44 = epsb;
    }
    a11 = a_ref(l, l) / b11;
    a12 = a_ref(l, l1) / b22;
    a21 = a_ref(l1, l) / b11;
    a22 = a_ref(l1, l1) / b22;
    a33 = a_ref(m2, m2) / b33;
    a34 = a_ref(m2, m1) / b44;
    a43 = a_ref(m1, m2) / b33;
    a44 = a_ref(m1, m1) / b44;
    b12 = b_ref(l, l1) / b22;
    b34 = b_ref(m2, m1) / b44;
    a10 = ((a33 - a11) * (a44 - a11) - a34 * a43 + a43 * b34 * a11) / a21 + 
            a12 - a11 * b12;
    a20 = a22 - a11 - a21 * b12 - (a33 - a11) - (a44 - a11) + a43 * b34;
    a30 = a_ref(l + 2, l1) / b22;
    goto L12;
L11:
    a10 = zero;
    a20 = one;
    a30 = ot116;
L12:
    old1 = (r__1 = a_ref(m1, m1 - 1), abs(r__1));
    old2 = (r__1 = a_ref(m1 - 1, m1 - 2), abs(r__1));
    if (! wantx) {
        lor1 = l;
    }
    if (wantx) {
        lor1 = 1;
    }
    if (! wantx) {
        morn = m1;
    }
    if (wantx) {
        morn = *n;
    }
    i__1 = m2;
    for (k = l; k <= i__1; ++k) {
        mid = k != m2;
        k1 = k + 1;
        k2 = k + 2;
        k3 = k + 3;
        if (k3 > m1) {
            k3 = m1;
        }
        km1 = k - 1;
        if (km1 < l) {
            km1 = l;
        }
        if (k == l) {
            am13r_c(&a10, &a20, &a30, &u1, &u2, &u3, &v1, &v2, &v3);
        }
        if (k > l && k < m2) {
            am13r_c(&a_ref(k, km1), &a_ref(k1, km1), &a_ref(k2, km1), &u1, &u2,
                     &u3, &v1, &v2, &v3);
        }
        if (k == m2) {
            am12r_c(&a_ref(k, km1), &a_ref(k1, km1), &u1, &u2, &v1, &v2);
        }
        if (u1 != one) {
            goto L14;
        }
        i__2 = morn;
        for (j = km1; j <= i__2; ++j) {
            t = a_ref(k, j) + u2 * a_ref(k1, j);
            if (mid) {
                t += u3 * a_ref(k2, j);
            }
            a_ref(k, j) = a_ref(k, j) + t * v1;
            a_ref(k1, j) = a_ref(k1, j) + t * v2;
            if (mid) {
                a_ref(k2, j) = a_ref(k2, j) + t * v3;
            }
            t = b_ref(k, j) + u2 * b_ref(k1, j);
            if (mid) {
                t += u3 * b_ref(k2, j);
            }
            b_ref(k, j) = b_ref(k, j) + t * v1;
            b_ref(k1, j) = b_ref(k1, j) + t * v2;
            if (mid) {
                b_ref(k2, j) = b_ref(k2, j) + t * v3;
            }
/* L13: */
        }
        if (k == l) {
            goto L14;
        }
        a_ref(k1, k - 1) = zero;
        if (mid) {
            a_ref(k2, k - 1) = zero;
        }
L14:
        if (k == m2) {
            goto L17;
        }
        am13r_c(&b_ref(k2, k2), &b_ref(k2, k1), &b_ref(k2, k), &u1, &u2, &u3, &
                v1, &v2, &v3);
        if (u1 != one) {
            goto L17;
        }
        i__2 = k3;
        for (i__ = lor1; i__ <= i__2; ++i__) {
            t = a_ref(i__, k2) + u2 * a_ref(i__, k1) + u3 * a_ref(i__, k);
            a_ref(i__, k2) = a_ref(i__, k2) + t * v1;
            a_ref(i__, k1) = a_ref(i__, k1) + t * v2;
            a_ref(i__, k) = a_ref(i__, k) + t * v3;
            t = b_ref(i__, k2) + u2 * b_ref(i__, k1) + u3 * b_ref(i__, k);
            b_ref(i__, k2) = b_ref(i__, k2) + t * v1;
            b_ref(i__, k1) = b_ref(i__, k1) + t * v2;
            b_ref(i__, k) = b_ref(i__, k) + t * v3;
/* L15: */
        }
        b_ref(k2, k) = zero;
        b_ref(k2, k1) = zero;
        if (! wantx) {
            goto L17;
        }
        i__2 = *n;
        for (i__ = 1; i__ <= i__2; ++i__) {
            t = z___ref(i__, k2) + u2 * z___ref(i__, k1) + u3 * z___ref(i__, 
                    k);
            z___ref(i__, k2) = z___ref(i__, k2) + t * v1;
            z___ref(i__, k1) = z___ref(i__, k1) + t * v2;
            z___ref(i__, k) = z___ref(i__, k) + t * v3;
/* L16: */
        }
L17:
        am12r_c(&b_ref(k1, k1), &b_ref(k1, k), &u1, &u2, &v1, &v2);
        if (u1 != one) {
            goto L20;
        }
        i__2 = k3;
        for (i__ = lor1; i__ <= i__2; ++i__) {
            t = a_ref(i__, k1) + u2 * a_ref(i__, k);
            a_ref(i__, k1) = a_ref(i__, k1) + t * v1;
            a_ref(i__, k) = a_ref(i__, k) + t * v2;
            t = b_ref(i__, k1) + u2 * b_ref(i__, k);
            b_ref(i__, k1) = b_ref(i__, k1) + t * v1;
            b_ref(i__, k) = b_ref(i__, k) + t * v2;
/* L18: */
        }
        b_ref(k1, k) = zero;
        if (! wantx) {
            goto L20;
        }
        i__2 = *n;
        for (i__ = 1; i__ <= i__2; ++i__) {
            t = z___ref(i__, k1) + u2 * z___ref(i__, k);
            z___ref(i__, k1) = z___ref(i__, k1) + t * v1;
            z___ref(i__, k) = z___ref(i__, k) + t * v2;
/* L19: */
        }
L20:
        ;
    }
    goto L3;
L21:
    *ierr = m1 + 128;
L22:
    return 0;
} /* aft0r_c */

#undef z___ref
#undef b_ref
#undef a_ref
