/* agt1r.f -- translated by f2c (version 19970805).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__1 = 1;
static integer c__42 = 42;

/* Subroutine */ int agt1r_c(real *a, real *b, real *alfr, real *alfi,
        real *beta, integer *n, integer *ierr)
{
    /* Initialized data */

    static real zero = 0.f;
    static real one = 1.f;
    static real half = .5f;
    static real sys051 = 1.192093e-7f;

    /* System generated locals */
    integer a_dim1, a_offset, b_dim1, b_offset, i__1, i__2;
    real r__1, r__2, r__3, r__4;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    extern /* Subroutine */ int am12c_c(real *, real *, real *, real *, real *,
             real *, real *), am12r_c(real *, real *, real *, real *, real *,
            real *);
    static real epsb;
    static logical flip;
    extern /* Subroutine */ int aft0r_c(real *, real *, real *, integer *,
            integer *, integer *);
    static real c__, e, f, d__;
    static integer i__, j, l, m;
    static real r__, t;
    extern /* Subroutine */ int utag10_c(integer *, integer *);
    static real bnorm, u1, u2, v1, v2, a11, a12, a21, a22, b11, b12, b22, ei, 
            an, bn, cq, er, cz, ti, tr, a11i, a12i, a21i, a22i, bdi, a11r, 
            a12r, a21r, a22r, bni, bdr, eps, sqi, ssi, sqr, szi, ssr, szr;


#define a_ref(a_1,a_2) a[(a_2)*a_dim1 + a_1]
#define b_ref(a_1,a_2) b[(a_2)*b_dim1 + a_1]

    /* Parameter adjustments */
    --beta;
    --alfi;
    --alfr;
    b_dim1 = *n;
    b_offset = b_dim1 + 1;
    b -= b_offset;
    a_dim1 = *n;
    a_offset = a_dim1 + 1;
    a -= a_offset;

    /* Function Body */
    eps = sys051;
    *ierr = 0;
    aft0r_c(&a[a_offset], &b[b_offset], &a[a_offset], n, &c__1, ierr);
    bnorm = zero;
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        bni = zero;
        i__2 = *n;
        for (j = 1; j <= i__2; ++j) {
            bni += (r__1 = b_ref(i__, j), abs(r__1));
/* L1: */
        }
        if (bni > bnorm) {
            bnorm = bni;
        }
/* L2: */
    }
    if (bnorm == zero) {
        bnorm = eps;
    }
    epsb = eps * bnorm;
    m = *n;
L3:
    if (m == 1) {
        goto L4;
    }
    if (a_ref(m, m - 1) != zero) {
        goto L5;
    }
L4:
    alfr[m] = a_ref(m, m);
    if (b_ref(m, m) < zero) {
        alfr[m] = -alfr[m];
    }
    beta[m] = (r__1 = b_ref(m, m), abs(r__1));
    alfi[m] = zero;
    --m;
    goto L15;
L5:
    l = m - 1;
    if ((r__1 = b_ref(l, l), abs(r__1)) > epsb) {
        goto L6;
    }
    b_ref(l, l) = zero;
    am12r_c(&a_ref(l, l), &a_ref(m, l), &u1, &u2, &v1, &v2);
    goto L11;
L6:
    if ((r__1 = b_ref(m, m), abs(r__1)) > epsb) {
        goto L7;
    }
    b_ref(m, m) = zero;
    am12r_c(&a_ref(m, m), &a_ref(m, l), &u1, &u2, &v1, &v2);
    bn = zero;
    goto L8;
L7:
    an = (r__1 = a_ref(l, l), abs(r__1)) + (r__2 = a_ref(l, m), abs(r__2)) + (
            r__3 = a_ref(m, l), abs(r__3)) + (r__4 = a_ref(m, m), abs(r__4));
    bn = (r__1 = b_ref(l, l), abs(r__1)) + (r__2 = b_ref(l, m), abs(r__2)) + (
            r__3 = b_ref(m, m), abs(r__3));
    f = one / an;
    a11 = a_ref(l, l) * f;
    a12 = a_ref(l, m) * f;
    a21 = a_ref(m, l) * f;
    a22 = a_ref(m, m) * f;
    f = one / bn;
    b11 = b_ref(l, l) * f;
    b12 = b_ref(l, m) * f;
    b22 = b_ref(m, m) * f;
    e = a11 / b11;
    c__ = ((a22 - e * b22) / b22 - a21 * b12 / (b11 * b22)) * half;
    d__ = c__ * c__ + a21 * (a12 - e * b12) / (b11 * b22);
    if (d__ < zero) {
        goto L14;
    }
    if (c__ >= zero) {
        e += c__ + (real)sqrt(d__);
    }
    if (c__ < zero) {
        e += c__ - (real)sqrt(d__);
    }
    a11 -= e * b11;
    a12 -= e * b12;
    a22 -= e * b22;
    flip = abs(a11) + abs(a12) >= abs(a21) + abs(a22);
    if (flip) {
        am12r_c(&a12, &a11, &u1, &u2, &v1, &v2);
    }
    if (! flip) {
        am12r_c(&a22, &a21, &u1, &u2, &v1, &v2);
    }
L8:
    if (u1 != one) {
        goto L10;
    }
    i__1 = m;
    for (i__ = 1; i__ <= i__1; ++i__) {
        t = a_ref(i__, m) + u2 * a_ref(i__, l);
        a_ref(i__, m) = a_ref(i__, m) + v1 * t;
        a_ref(i__, l) = a_ref(i__, l) + v2 * t;
        t = b_ref(i__, m) + u2 * b_ref(i__, l);
        b_ref(i__, m) = b_ref(i__, m) + v1 * t;
        b_ref(i__, l) = b_ref(i__, l) + v2 * t;
/* L9: */
    }
L10:
    if (bn == zero) {
        goto L13;
    }
    flip = an >= abs(e) * bn;
    if (flip) {
        am12r_c(&b_ref(l, l), &b_ref(m, l), &u1, &u2, &v1, &v2);
    }
    if (! flip) {
        am12r_c(&a_ref(l, l), &a_ref(m, l), &u1, &u2, &v1, &v2);
    }
L11:
    if (u1 != one) {
        goto L13;
    }
    i__1 = *n;
    for (j = l; j <= i__1; ++j) {
        t = a_ref(l, j) + u2 * a_ref(m, j);
        a_ref(l, j) = a_ref(l, j) + v1 * t;
        a_ref(m, j) = a_ref(m, j) + v2 * t;
        t = b_ref(l, j) + u2 * b_ref(m, j);
        b_ref(l, j) = b_ref(l, j) + v1 * t;
        b_ref(m, j) = b_ref(m, j) + v2 * t;
/* L12: */
    }
L13:
    a_ref(m, l) = zero;
    b_ref(m, l) = zero;
    alfr[l] = a_ref(l, l);
    alfr[m] = a_ref(m, m);
    if (b_ref(l, l) < zero) {
        alfr[l] = -alfr[l];
    }
    if (b_ref(m, m) < zero) {
        alfr[m] = -alfr[m];
    }
    beta[l] = (r__1 = b_ref(l, l), abs(r__1));
    beta[m] = (r__1 = b_ref(m, m), abs(r__1));
    alfi[m] = zero;
    alfi[l] = zero;
    m += -2;
    goto L15;
L14:
    er = e + c__;
    ei = (real)sqrt(-d__);
    a11r = a11 - er * b11;
    a11i = ei * b11;
    a12r = a12 - er * b12;
    a12i = ei * b12;
    a21r = a21;
    a21i = zero;
    a22r = a22 - er * b22;
    a22i = ei * b22;
    flip = abs(a11r) + abs(a11i) + abs(a12r) + abs(a12i) >= abs(a21r) +
            abs(a22r) + abs(a22i);
    if (flip) {
        r__1 = -a11r;
        r__2 = -a11i;
        am12c_c(&a12r, &a12i, &r__1, &r__2, &cz, &szr, &szi);
    }
    if (! flip) {
        r__1 = -a21r;
        r__2 = -a21i;
        am12c_c(&a22r, &a22i, &r__1, &r__2, &cz, &szr, &szi);
    }
    flip = an >= (abs(er) + abs(ei)) * bn;
    if (flip) {
        r__1 = cz * b11 + szr * b12;
        r__2 = szi * b12;
        r__3 = szr * b22;
        r__4 = szi * b22;
        am12c_c(&r__1, &r__2, &r__3, &r__4, &cq, &sqr, &sqi);
    }
    if (! flip) {
        r__1 = cz * a11 + szr * a12;
        r__2 = szi * a12;
        r__3 = cz * a21 + szr * a22;
        r__4 = szi * a22;
        am12c_c(&r__1, &r__2, &r__3, &r__4, &cq, &sqr, &sqi);
    }
    ssr = sqr * szr + sqi * szi;
    ssi = sqr * szi - sqi * szr;
    tr = cq * cz * a11 + cq * szr * a12 + sqr * cz * a21 + ssr * a22;
    ti = cq * szi * a12 - sqi * cz * a21 + ssi * a22;
    bdr = cq * cz * b11 + cq * szr * b12 + ssr * b22;
    bdi = cq * szi * b12 + ssi * b22;
    r__ = (real)sqrt(bdr * bdr + bdi * bdi);
    beta[l] = bn * r__;
    alfr[l] = an * (tr * bdr + ti * bdi) / r__;
    alfi[l] = an * (tr * bdi - ti * bdr) / r__;
    tr = ssr * a11 - sqr * cz * a12 - cq * szr * a21 + cq * cz * a22;
    ti = -ssi * a11 - sqi * cz * a12 + cq * szi * a21;
    bdr = ssr * b11 - sqr * cz * b12 + cq * cz * b22;
    bdi = -ssi * b11 - sqi * cz * b12;
    r__ = (real)sqrt(bdr * bdr + bdi * bdi);
    beta[m] = bn * r__;
    alfr[m] = an * (tr * bdr + ti * bdi) / r__;
    alfi[m] = an * (tr * bdi - ti * bdr) / r__;
    m += -2;
L15:
    if (m > 0) {
        goto L3;
    }
    if (*ierr != 0) {
        utag10_c(ierr, &c__42);
    }
    return 0;
} /* agt1r_c */

#undef b_ref
#undef a_ref
